/* GCC */

#include <cstdio>
#include <vector>
#include <queue>
#include <algorithm>

#include <pair.h>

#define mp make_pair

using namespace std;

const int nMax = 516;
const int INF = 1e9 + 16;

vector<int> g[2][nMax];

int assoc[2][nMax];

queue< pair<int,int> > q;

int main ()
{
    freopen ("assoc.in", "r", stdin);
    freopen ("assoc.out", "w", stdout);
    int n, a, b;

    scanf ("%d %d %d\n", &n, &a, &b);

    a--, b--;

    if (a == b)
    {
        printf ("1\n");
        return 0;
    }

    for (int k = 0; k < 2; k++)
        for (int i = 0; i < n; i++)
        {
            int x;
            char c;
            do
            {
                scanf ("%d%c", &x, &c);
                g[k][i].push_back (x-1);
            } while (c != '\n');

        }
    for (int k = 0; k < 2; k++)
        for (int i = 0; i < n; i++)
            assoc[k][i] = INF;

    assoc[0][a] = 1;
    q.push ( mp(a,0) );

    while (!q.empty())
    {
        pair<int,int> t = q.front(); q.pop();
        int current = t.first;
        int p = t.second;

        for (int i = 0; i < g[1-p][current].size(); i++)
        {
            int next = g[1-p][current][i];
            if ( assoc[1-p][next] == INF )
            {
                assoc[1-p][next] = assoc[p][current]+1;
                q.push ( mp (next,1-p) );
            }
            else
                assoc[1-p][next] = min (assoc[1-p][next], assoc[p][current]+1);
        }
    }

    if ( assoc[0][b] == INF && assoc[1][b] == INF )
    {
        printf ("0\n");
        return 0;
    }
    else
        printf ("%d\n", min (assoc[0][b], assoc[1][b]));

    return 0;
}
