/* GCC */

#include <cstdio>
#include <vector>
#include <algorithm>

using namespace std;

int n, a, b;
vector<int> g[1000];
int w[1000];

int main() {
    for(int i = 0; i < 1000; i++) {
        w[i] = 1024;
    }

    freopen("assoc.in", "r", stdin);
    freopen("assoc.out", "w", stdout);

    scanf("%d%d%d", &n, &a, &b); a--; b--;

    if(a == b) {
        puts("1");
        return 0;
    }

    for(int i = 0, v; i < n; i++) {
        for(char c;;) {
            scanf("%d%c", &v, &c);
            g[i].push_back(n + v - 1);
            if(c != ' ') break;
        }
    }

    for(int i = n, v; i < 2*n; i++) {
        for(char c;;) {
            scanf("%d%c", &v, &c);
            g[i].push_back(v - 1);
            if(c != ' ') break;
        }
    }

    vector<int> *q = new vector<int>, *nq = new vector<int>;
    q->reserve(512);
    nq->reserve(512);
    q->push_back(n + a);
    w[n+a] = 1;

    for(int step = 2; !q->empty(); step++) {
        for(int i = 0; i < q->size(); i++) {
            int &nxt = (*q)[i];
            for(int j = 0; j < g[nxt].size(); j++) {
                int &to = g[nxt][j];
                if(w[to] == 1024) {
                    w[to] = step;
                    nq->push_back(to);
                    if(to == b || to == n + b) {
                        printf("%d\n", step);
                        return 0;
                    }
                }
            }
        }
        q->clear();
        swap(q, nq);
    }

    puts("0");

    return 0;
}
