/* GCC */
#include <fstream>
#include <string>
#include <sstream>
#include <queue>

using namespace std;

int main(void)
{
    size_t n, a, b, temp;
    ifstream in("assoc.in");
    string str;
    in >> n >> a >> b;
    in.get();
    unsigned short** gr = new unsigned short*[n];
    for(size_t i = 0; i < n; i++)
    {
               gr[i] = new unsigned short[n];
               for(size_t j = 0; j < n; j++)
                          gr[i][j] = 0;
               getline(in, str);
               stringstream ss(str);
               while(ss.good())
               {
                               ss >> temp;
                               gr[i][temp-1]++;
               }
    }
    for(size_t i = 0; i < n; i++)
    {
               getline(in, str);
               stringstream ss(str);
               while(ss.good())
               {
                               ss >> temp;
                               gr[i][temp-1]+=2;
               }
    }
    in.close();
    a--;
    b--;
    queue<unsigned short> move;
    move.push(a);
    unsigned short moves;
    for(moves = 1; moves < 1001; moves++)
    {
                 unsigned short count = move.size();
                 for(size_t mov = 0; mov < count; mov++)
                 {
                      if(move.front() == b)
                           goto found;
                      for(unsigned short i = 0; i < n; i++)
                                   if((gr[move.front()][i] > 1 && (moves%2)) || (gr[move.front()][i]%2 && !(moves%2)))
                                               move.push(i);
                      move.pop();
                 }
    }
found:
    ofstream out("assoc.out");
    out << moves%1001 << endl;
    out.close();
    for(size_t i = 0; i < n; i++)
               delete[] gr[i];
    delete[] gr;
    return 0;
}
