/* GCC */

#include <cstdio>
#include <vector>
#include <queue>
#include <algorithm>
#include <pair.h>

#define mp make_pair

using namespace std;

vector<int> g[6];

int ans = -1;

void f (int cur, int sum, int k)
{
    if (k == 0)
    {
        ans = max (ans, sum);
        return;
    }
    for (int i = 0; i < g[cur].size(); i++)
    {
        int next = g[cur][i];
        f (next, sum + next + 1, k-1);
    }
}

int main ()
{
    freopen ("die.in", "r", stdin);
    freopen ("die.out", "w", stdout);

    int a, b;
    scanf ("%d %d", &a, &b);

    for (int i = 0; i < 6; i++)
    {
        int x;
        scanf ("%d", &x);
        if (x != 0)
            g[i].push_back (x-1);
        else
            for (int t = 0; t < 6; t++)
                g[i].push_back (t);
    }

    int n = (1<<a) + b;

    for (int i = 0; i < 6; i++)
        f(i, i+1, n-1);

    printf ("%d\n", ans);

    return 0;
}
