/* GCC */

#include <iostream>
#include <fstream>
#include <queue>
#include <climits>
using namespace std;

int* dist = new int[6];
unsigned long long cnt;

unsigned long long bfs(bool mtx[6][6], int start)
{
    int size = 6;
    queue<int> q;
    for (int i=0;i<size;++i)
    {
        dist[i] = INT_MAX;

    }
    dist[start] = 0;
    int index = start;
    q.push(start);
    for (int kl=0;kl<cnt && !q.empty();++kl)
    {
        index = q.front();
        q.pop();
        for (int i=0; i<size; ++i)
            if (mtx[index][i])
            {
                dist[i] = dist[index] + i;
                q.push(i);
            }
    }
    for (int i =0;i<6;++i)
        if (dist[i]==INT_MAX) dist[i] = 0;
    return *max_element(dist, dist+6);

}
typedef unsigned long long it;

it pow(it a, it b)
{
    if (b == 0) return 1;
    else return a*pow(a, b-1);
}

int main()
{
    ifstream fin("die.in");
    ofstream fout("die.out");
    int a, b;

    bool k[6][6];
    for (int i=0;i<6;++i)
        for (int j=0;j<6;++j)
            k[i][j] = false;
    fin >> a >> b;
    cnt = pow(2, a) + b;
    for (int i=0;i<6;++i)
    {
        int t;
        fin >> t;
        if (t == 0)
        {
            for (int j =0;j<6;++j)
                k[i][j] = 1;
        }
        else
            k[i][t-1] = 1;
    }
    fin.close();
    unsigned long long ans[6];
    for (int i=0;i<6;++i)
        ans[i] = 0;
    for (int i=0;i<6;++i)
        ans[i] = bfs(k, i);
    for (int i=0;i<6;++i)
        cout << ans[i] << endl;
    fout << *max_element(ans, ans+6) << endl;;


    fout.close();
    return 0;
}
